;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
;@  -, 2         @
;@  AT89C2051. Copyright (C) 2005 by   .    @
;@ : 0.1 C.                                             @
;@        11,059 .   @
;@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

 
 
		CSEG

; __________________ ______________________________

seg_a		bit p1.0
seg_b		bit p1.1
seg_c		bit p1.3
seg_d		bit p1.6
seg_e		bit p1.7
seg_f		bit p1.2
seg_g		bit p1.4
seg_h		bit p1.5
anod_0	bit p3.7
anod_1	bit p3.4
anod_2	bit p3.5
dat		bit p3.1		; i2c
t_1wire	bit p3.2		;   .
knopka	bit p3.3
wyhod		bit p3.0		;   

;----------------------------

inf_1			equ	25h			;   eprom
rr10			data	26h
rr11			data	27h
ftry			data	28h			;    rom ds

; .

fcounter		data	29h
fcounter2	data	2Ah
crc			data	2Bh		;  .
ftemp			data	2Ch		;   rw_byte.

; .
ftemper_L	data	30h		;       
ftemper_h	data	31h		;  get_temperature.

fCNT_REM		data	32h
fCNT_PER_C	data	33h

; --------------------   . ----------------------------
rom_id0		data	34h
rom_id1		data	35h
rom_id2		data	36h
rom_id3		data	37h
rom_id4		data	38h
rom_id5		data	39h
rom_id6		data	3ah
rom_id7		data	3bh
;--------------------------------------------------------------------------
data_10h_2	equ	3ch		;  1,0 . 2 
data_2h_2	equ 	3dh		;  2 . 2 

data_ind		equ 	3eh		;  . 1

data_2_1		equ 	3fh		; 2 . 1 
data_1_1		equ 	40h		; 1 . 1 
data_0_1		equ 	41h		; 0 . 1 

data_2_2		equ	42h		; 2 . 2 
data_1_2		equ	43h		; 1 . 2 
data_0_2		equ	44h		; 0 . 2 

scan			equ	45h		; . 
data_10h		equ	46h		;  1,0 . ()
data_2h		equ	47h		;  2 . ()
byte_t1		equ	48h		;  1
byte_t0		equ	49h		;  0
knopka1  	equ	4ah
klava			equ	4bh 		;    .
klava01		equ	4ch     	; .    "0"
klava02		equ	4dh		; .    "0"
data_mig		equ	4eh		;    
data_dev		equ	4fh		;  . eprom   /
data_add		equ	50h		;    eprom
ep_i			equ	51h		;   inf_1
ep_2hl		equ	52h		;  2h   
ep_10hl		equ	53h		;  10h   
ep_2hh		equ	54h		;  2h   
ep_10hh		equ	55h		;  10h   

data_2_l		equ 	59h		; 2 .   .
data_1_l		equ 	5ah		; 1 .   .
data_0_l		equ 	5bh		; 0 .   .

data_2_h		equ	5ch		; 2 .   .
data_1_h		equ	5dh		; 1 .   .
data_0_h		equ	5eh		; 0 .   .

data_res		equ	5fh		;    .
data_ind1	equ	60h		;   2
set_add1		equ	61h		;  1  
set_add2		equ	69h		;  2 
ep_data		equ	71h		;   eprom
data_ind2	equ	72h		;.  .   1
data_ind3	equ	73h		;.  .   1

crc_ok		bit	2dh.0		;   crc   2
res_1wire	bit	20h.0		;  -
m_rom_1		bit	20h.1		;  
m_rom_2		bit	20h.2		;  -
m_rom_3		bit	20h.3		;  0
get_t1_b		bit	20h.4		; 
get_t2_b		bit	20h.5		; 
get_t3_b		bit	20h.6		; 
get_t4_b		bit	20h.7		; 
minus			bit	21h.0		;    
ind_low		bit	21h.1		;     .
ind_hi		bit	21h.2		;     .
set_rom_b	bit	21h.3		;  
inf_b			bit	21h.4		;     eprom
ndat			bit	25h.0		;    
knopka_off	bit	21h.5		;    
mig			bit	25h.1		;    
ack_err		bit	21h.7		;   ACK
nagrev		bit	22h.0		;   
prog1			bit	22h.1		;   
prog2			bit	22h.2		;    1
prog3			bit	22h.3		;    2


; 
const_mig	equ	5			;     , 765*5=3,8
pvt			equ	10			;     10 = . 30 ./

; public start
start:
		jmp	init				;  
		
; End of function start



; _____________________________________________________________________________
		org 0Bh


; Timer	interrupt 0 (TIM0)

		ajmp	timint0
; End of function timint0

		org 1Bh

; _________________ timint0____________________________________

timint0:				
		push	acc
		push	psw
		push	00
		mov	TH0, #0f5h 	; Timer0 - High Byte ( 3 )
		mov	TL0, #03fh	; Timer0 - Low Byte
		dec	byte_t0		;  
		jb		ind_low, ndat6
		jb		ind_hi, ndat7		
		jb		ndat, ndat4
		mov	r0, #data_0_1
		jmp	ndat5
ndat4:
		mov	r0, #data_0_2
ndat5:		
		inc	scan
		mov	a, scan
		anl	a, #3
		cjne	a, #3, scan_norm
		clr	a
		xch	a, scan
		setb	anod_2
		mov	p1, @r0
		clr	anod_0
		jmp	scan_end
ndat6:
		mov	r0, #data_0_l
		jmp	ndat5
ndat7:
		mov	r0, #data_0_h
		jmp	ndat5
				
scan_norm:		
		dec	a
		jz	scan_1     		; #scan=1
		jmp	scan_2		; #scan=2
;______________________________



scan_1:				
		setb	anod_0
		dec	r0		
		mov	P1, @r0
		clr	anod_1
		jmp	scan_end
			 
; _____________________________

scan_2:				
		setb	anod_1
		dec	r0
		dec	r0		
		mov	P1, @r0
		clr	anod_2
;____________________ _______________________________

scan_end:
		jb		knopka, scan_end3_1			;    
      jnb	knopka_off, scan_end2_1 
		mov	klava, scan
		clr	knopka_off
		mov	a, klava
		jb		prog1, end_pp1		
		jnz	scan_end4						;   ."0",  
;   ."0"
		jb		ind_low, scan_end7
		jb		ind_hi, scan_end8		
		jb		mig, m1
		cpl	ndat
		setb	inf_b
m1:
		clr	mig
		setb	inf_b		
scan_end2_1:
		jmp	scan_end2
scan_end3_1:
		jmp	scan_end3		
end_pp1:
		jmp	end_pp	
; +1  
scan_end7:
		call	low_plus
		jmp	scan_end2
; +1  
scan_end8:
		call	hi_plus		
		jmp	scan_end2

					
;   ."1"
scan_end4:
		cjne	a, #1, scan_end5			;   ."1",  
		jbc	ind_low, scan_end6
		jbc	ind_hi, scan_end2
		setb	ind_low
		call	indic_low	
		jmp	scan_end2
scan_end6:
		setb	ind_hi
		mov	r0, #data_2_h
		call	indic_hi
		jmp	scan_end2
							
		
;   ."2"
scan_end5:
		jb		ind_low, scan_end20
		jb		ind_hi, scan_end21	
		jmp	scan_end2
; -1  
scan_end20:
		call	low_minus
		jmp	scan_end2
; -1  
scan_end21:
		call	hi_minus
		jmp	scan_end2
						
scan_end3:
		djnz	knopka1, scan_end1 
		setb	knopka_off
		mov	klava, #0ffh
		mov	data_ind, #0
		mov	data_ind1, #0
		mov	data_ind2, #0
		mov	data_ind3, #0
scan_end2:
		mov	knopka1, #3
		jb		prog1, end_pp1			

				 			
;____________________end  ___________________________

;____________________.    "0"___

scan_end1:
		mov	a, klava
		jnz	scan_end10		; !!!10
		jb		ind_hi, scan_end14
		jb		ind_low, scan_end14
		xch	a, klava01		;  .0		
		add	a, #1
		xch	a, klava01
		xch	a, klava02		
		addc	a,	#0
		xch	a, klava02
		jmp	scan_end12			
;    		
scan_end14:
		djnz	data_ind, scan_end12
		jb		ind_hi, scan_end13		
		jnb	ind_low, scan_end12
;  
		mov	data_ind, #pvt		
		call	low_plus  				
		jmp	scan_end12
scan_end13:
;  
		mov	data_ind, #pvt
		call	hi_plus		  				
		jmp	scan_end12
		
scan_end10:
		cjne	a, #0ffh, scan_end12_1
		xch	a, klava02
		jz		scan_end11
		setb	mig
		setb	inf_b
scan_end11:
		clr	a
		mov	klava02, a
		xch	a, klava01		 			
;________________end .    "0"___      
      
;____________________.    "2"___
scan_end12_1:
		mov	a, klava
		cjne	a, #2, scan_end12_2 
		jb		ind_hi, scan_end22
		jnb	ind_low, scan_end12
;    		
;  
		djnz	data_ind1, scan_end12
		mov	data_ind1, #pvt		
		call	low_minus  				
		jmp	scan_end12
scan_end22:
;  
		djnz	data_ind1, scan_end12
		mov	data_ind1, #pvt
		call	hi_minus		  				

;________________end .    "2"___


;____________________.    "1"___
scan_end12_2:
		mov	a, data_ind2 
;		clr	c
		add	a, #1
		xch	a, data_ind2
		mov	a, data_ind3
		addc	a, #0
		cjne	a, #5, t1_1
		setb	prog1
scan_end12:
		clr	a
		mov	data_ind2, a
t1_1:
		xch	a, data_ind3
				 


;________________end .    "1"___


		      
;scan_end12:
		jb		res_1wire, res_1wire_1	;  reset_1wire
		jb		m_rom_1, m_rom_1_1  		;match_rom_1
		jb		m_rom_2, m_rom_1_2  		;match_rom_2
		jb		m_rom_3, m_rom_1_3  		;match_rom_3
		jb		get_t1_b, get_t1_m
		jb		get_t2_b, get_t2_m
		jb		get_t3_b, get_t3_m
		jb		get_t4_b, get_t4_m
		
		jmp	end_pp
		
res_1wire_1:
		call	reset_1wire                                     		
		clr	res_1wire
		jmp	end_pp
		
m_rom_1_1:
		call	match_rom_1
		clr	m_rom_1
		jmp	end_pp

m_rom_1_2:	
		call	match_rom_2
		clr	m_rom_2
		jmp	end_pp
		
m_rom_1_3:	
		call	match_rom_3
		clr	m_rom_3
		jmp	end_pp
		
get_t1_m:
		call	get_t1
		clr	get_t1_b
		jmp	end_pp

get_t2_m:
		call	get_t2
		clr	get_t2_b
		jmp	end_pp

get_t3_m:
		call	get_t3
		clr	get_t3_b
		jmp	end_pp

get_t4_m:
		call	get_t4
		clr	get_t4_b
		jmp	end_pp
		 
		
						
end_pp:
		pop	00
		pop	PSW
		pop	ACC
		reti

;____________________ timint0____________________________________________


; _______________________ _____________________________________
tabl:
		db	30h	; 0
		db	0F5h	; 1
		db	02ch	; 2
		db	0a4h	; 3
		db	0e1h	; 4
		db	0a2h	; 5		
		db	22h	; 6
		db	0f4h	; 7
		db	20h	; 8 
		db	0a0h	; 9
		db	60h	; a
		db	23h	; b
		db	3ah	; c
		db	25h	; d
		db 2ah	; e
		db	6ah	; f
		db	0ffh	;  
		db	0efh	; -
		db	0e8h	; o
		db 63h	; h
		db	3bh	; L

		
;__________.   ________________________
		
conv_h:
		push	ACC
		push	PSW
		push	dph
		push	dpl
		mov	DPTR, #tabl
		mov	a, data_2h
		mov	c, acc.7
		anl	a, #0fh
;        (-),  
		jnz	con_t
		mov	a, #0ffh
		jnc 	plus
		clr	acc.4       ; . . g
		jmp	plus
con_t:
		movc	A, @A+DPTR
		jnc 	plus   
      anl	a, #0dfh
plus:
      mov	@r0, a
      inc	r0
		mov	a, data_10h
		swap	a
		anl	a, #0fh
		movc	A, @A+DPTR
		anl	a, #0dfh
      mov	@r0, a
      inc	r0
		mov	a, data_10h
		anl	a, #0fh
		movc	A, @A+DPTR
		jnb	set_rom_b, ndat10
		anl	a, #0dfh			;. 
ndat10:
		mov	@r0, a
		pop	dpl
		pop	dph
		pop	ACC
		pop	PSW
		ret
 ;__________________________________________________________    
      




;________________________________________________________________
; bin-dec   bin max = 270fh (9999), in r7:r6, out dptr  
;________________________________________________________________
		
bin_dec:		
		mov	r5, #03h   ;1000
		mov	r4, #0e8h
		call	idiv_16
	   mov	a, r6              
	   swap	a
	   mov	dph, a
	   mov	r7, 5
	   mov	r6, 4
	   mov	r5, #0   ;100
		mov	r4, #100
		call	idiv_16
		mov	a, r6
		orl	a, dph
		xch	a, dph
		mov	a, r4
		mov	b,#10		; Divide By 10
		div	ab			; Do Divide
		swap	a			; Move Result To High Of A
		orl	a,b		; OR In Remainder
		mov	dpl,a		; Move To DPL
		ret

	   

	   
	   
;-----------------------------------------------------------------------------
;  .
;-----------------------------------------------------------------------------

; ______________________ init ________________________________________________

init:				
		mov	R0, #7Fh		;  
		clr	A

clr_ram:						;  
		mov	@R0, A
		djnz	R0, clr_ram
		
;--------------- ff    ()------------		
		mov	R0, #data_2_1		;  .
		mov	a, #0ffh
		mov	b, #6       		;  

set_ram:								; . 
		mov	@R0, a
		inc	r0
		djnz	b, set_ram
;-----------end  ff    ()------------
		
;  
		mov	a, #0ffh
		mov	p1, a
		mov	p3, a
		clr	wyhod
		mov	knopka1, #3
		clr	inf_b
  		
		mov	TMOD, #11h	; Timer	Mode
		mov	tl0,	#0
		mov	th0,	#0ffh
		setb	TCON.4		; TCON.4 - TIMER 0 ON/OFF CONTROL
		setb	IE.1			; IE.1 - TIMER 0 INTERRUPT ENABLE
		setb	IE.7			; IE.7 - GLOBAL	INTERRUPT ENABLE
		mov	byte_t0, #5
		pause_15:
		mov   a, byte_t0
		jnz	pause_15
		mov	data_mig, #const_mig
		mov	data_res, #15

;---------------  ---------------------------			
		setb	res_1wire		
		jb		res_1wire, $
		mov	r0, #ep_i
		mov	data_add, #0
		call	read_at		;  eprom
		mov	a, ep_2hh
		anl	a, #0fh
		mov	ep_2hh, a
		mov	a, ep_2hl
		anl	a, #0fh
		mov	ep_2hl, a
		call	priv
		mov	r0, #set_add1
		mov	data_add, #10h
		call	read_at		;  eprom
		call	priv
		mov	r0, #set_add2
		mov	data_add, #20h
		call	read_at		;  eprom
;------------end   ------------------------

		mov	inf_1, ep_i 
		       
;________________________________________________________________________________
        
;  .
;________________________________________________________________________________

MainLoop:
		

;     
		setb	res_1wire		
		jb		res_1wire, $
;   
;not_ff:		
		jnb	prog1, not_ff
		jmp	progra
		
;---------  ----------------------------
not_ff:
;		mov	a,	klava
;		cjne	a,	#0ffh, not_ff
;---------end   ------------------------
;		clr	prog1
;---------    eprom------------------------
      jnb	inf_b, inf_b1
;		call	reset_1wire
		call	priv
		mov	ep_i, inf_1
		mov	r0, #ep_i
		mov	data_add, #0
		call	write_byte		;  eprom
		
		clr	inf_b		
inf_b1:
;---------end     eprom--------------------

;-------------------------------------------
		jnb	crc_ok, term_off   ;!  ,  
; .  
		mov	a,	ep_2hh
		clr	c
		subb	a, ep_2hl
		jc		term_off				; !     (. )		
		jz,	term3					;     (. )
;		clr	term_0
		jmp	reg	
term3:
; .  
		mov	a, ep_10hh
		clr	c
		subb	a, ep_10hl
		jc		term_off				; !    (. )		
		jnz,	reg					;      (. )
		jmp	term_off				;  
reg:

;  ,  . 
		mov	a, data_2h_2
		jnb	acc.7, term4 	
		setb	nagrev
		setb	wyhod
		jmp	term10		
term4:
		jnb		nagrev, term5
;  2    
		clr	c				
		mov	a, data_10h_2			
		subb	a, ep_10hh
		mov	a, data_2h_2
		subb	a, ep_2hh
		mov	nagrev, c
		mov	wyhod, c
		jmp	term10
;  2    
term5:
		clr	c				
		mov	a, data_10h_2			
		subb	a, ep_10hl
		mov	a, data_2h_2
		subb	a, ep_2hl
		mov	nagrev, c
		mov	wyhod, c
		jmp	term10

term_off:
		clr	nagrev
		clr	wyhod

term10:


;---------end ------------------------------

; Skip ROM       
		mov	a, #0cch		        
		call	rw_byte		;

;    
		mov	a, #044h        
		call	rw_byte				
        
;------------------------------------------------------------
;  0.75  ( ,   ).
		mov	byte_t0, #250
pause_1:
		mov   a, byte_t0
		jnz	pause_1
;------------------------------------------------------------

;---------   ---------------		
		jnb	mig, mig1
		djnz	data_mig, mig2
		cpl	ndat		
		
mig1:
		mov	data_mig, #const_mig 
		
mig2:
;---------end    ------------

;---------   ---------------		
		jb		ind_low, res1
		jb		ind_hi, res1
		jmp	res2
		
res1:
		mov	a, klava
		cjne	a, #0ffh, res2	
		djnz	data_res, res3
		clr	ind_low
		clr	ind_hi	
		
res2:
		mov	data_res, #15
		
res3:
;---------end    ------------------

;-------------------------------------------------------------
;      .
		call	temperatura
;-------------------------------------------------------------
  
		jmp	MainLoop
;-------------------------------------------------------------		
		
        

;-----------------------------------------------------------------------------
get_temperature:
		call	res_mat			;   .
		
;     "  ". 
		mov	a, #0beh
		call	rw_byte
		setb	get_t1_b			;  1.
		jb		get_t1_b, $
		setb	get_t2_b			;  2.
		jb		get_t2_b, $			
		setb	get_t3_b			;  3.
		jb		get_t3_b, $
		setb	get_t4_b			;  4.
		jb		get_t4_b, $
		clr	c
		xch	a, b
		subb	a, crc  			; a = a - crc
		jz		GT_crc_ok		;
       
;----------------crc   OK-----------------------------
      call	priv				;    0,  3 .
      jnb	set_rom_b, cr1
      clr	crc_ok
cr1:
		jb		set_rom_b, ndat3
		mov	r0, #data_2_1
		call	nadpis
		ret
ndat3:
		mov	r0, #data_2_2
		call	nadpis
		mov	a, #0dfh
		anl	a, @r0
		xch	a, @r0
		ret
;----------------end crc   OK-------------------------

				
;----------------crc OK---------------------------------------
GT_crc_ok:
		jnb	set_rom_b, cr2
		setb	crc_ok
cr2:
;  :

; R7:R6 = COUNT_PER_C - COUNT_REMAIN;
		mov	A, fCNT_PER_C
		clr	c
		subb	a, fCNT_REM
		mov	r6, a
		mov	r7, #0
; R7:R6 = R7:R6 * 10;
		mov	r4, #0ah
		mov	r5, #0
		call	imul_16
; R7:R6 = R7:R6 / COUNT_PER_C;
		mov	r4, fCNT_PER_C
		mov	r5, #0
		call	idiv_16
; rr11:rr10 = R7:R6 - 2;
		mov	a, r6
		mov	b, r7
		add	a, #0feh
		xch	a, b
		addc	a, #0ffh
		mov	rr10, b
		mov	rr11, a
; R7:R6 = TEMP_READ * 10
		mov	b, ftemper_L
		mov	a, ftemper_h
		rrc	a				;   .
		xch	a, b
		rrc	a				; .
		mov	r6, a
		mov	r7, ftemper_h
		mov	r4, #0ah
		mov	r5, #0
		call	imul_16
; ftempER = R7:R6 + rr11:rr10;
		mov	a, r6
		mov	b, r7
		add	a, rr10
		xch	a, b
		addc	a, rr11
		mov	ftemper_L, b
		mov	ftemper_h, a
; minus, 
		mov	a, ftemper_h
		rlc	a
		mov	minus, c
		jnb	minus, pls
		mov	a, ftemper_h
		cpl	a
		xch	a, r7
		mov	a, ftemper_L
		cpl	a
		clr	c
		add	a, #1
		xch	a, r6
		xch	a, r7
		add	a, #0
		
		xch	a, r7
		jmp	end_min
pls:
		mov	r7, ftemper_h
		mov	r6, ftemper_L 
end_min:
		call	bin_dec
		mov	data_2h, dph
		jnb	minus, pls_1
		xch	a, data_2h
		setb	acc.7
		xch	a, data_2h				
pls_1:
		mov	data_10h, dpl
		call	priv							;    0, t =  3 .
      jb		set_rom_b, ndat2
		mov	r0, #data_2_1
		call	conv_h
		ret
ndat2:
		mov	r0, #data_2_2
		mov	data_2h_2, data_2h		;    2 
		mov	data_10h_2, data_10h		; 
		call	conv_h
		ret
;----------------end crc OK-----------------------------------		
		

;-----------------------------------------------------------------------------
; .
;-----------------------------------------------------------------------------
; .
imul_16: ; R7:R6 = R5:R4 * R7:R6
		mov	a, r6
		mov	b, r4
		mul	ab
		xch	a, r6
		xch	a, b
		xch	a, r5
		mul	ab
		add	a, r5
		mov	r5, a
		mov	a, r7
		jz		imul16_skip
		mov	b, r4
		mul	ab
imul16_skip:
		add	a, r5
		mov	r7, a
		ret
;-----------------------------------------------------------------------------
;   .
; R7:R6 = R7:R6 / R5:R4;
; R5:R4 - .
idiv_16:
		cjne	r5, #0, idiv02
		cjne	r7, #0, idiv03
		mov	a, r6
		mov	b, r4
		div	ab
		jb		OV, idiv06
		mov	r6, a
		mov	r4, b
		ret
idiv02:
		mov	r3, #0
		mov	b, #8
idiv11:
		mov	a, r6
		add	a, r6
		mov	r6, a
		mov	a, r7
		rlc	a
		mov	r7, a
		mov	a, r3
		rlc   a
		mov	r3, a
		mov	a, r7
		subb	a, r4
		mov	a, r3
		subb	a, r5
		jc		idiv10
		mov	r3, a
		mov	a, r7
		subb	a, r4
		mov	r7, a
		inc	r6
idiv10:
		djnz	B, idiv11
		clr	a
		xch	a, r7
		xch	a, r4
		xch	a, r3
		xch	a, r5
		ret
idiv06:
		mov	r6, #0ffh
		mov	r7, #0ffh
		ret
idiv03:
		mov	a, r4
		cjne	a, #10h, idiv04
idiv04:
		jnc	idiv05
		mov	a, r7
		mov	b, r4
		div	ab
		mov	r7, a
		mov	a, r6
		anl	a, #0f0h
		orl	a, b
		swap	a
		mov	b, r4
		div	ab
		swap	a
		mov	r5, a
		mov	a, r6
		anl	a, #0fh
		swap	a
		orl	a, b
		swap	a
		mov	b, r4
		div	ab
		mov	r6, a
		mov	r4, b
		clr	a
		xch	a, r5
		orl	a, r6
		mov	r6, a
		ret
idiv05:
		mov	a, r7
		mov	b, r4
		div	ab
		jb		OV, idiv06
		mov	r7, #8
		xch	a, r7
		xch	a, b
		xch	a, r4
		xch	a, r3
idiv09:
		mov	a, r6
		add	a, r6
		mov	r6, a
		mov	a, r4
		rlc	a
		mov	r4, a
		jbc	CY, idiv07
		subb	a, r3
		jnc	idiv08
		djnz	b, idiv09
		ret
idiv07:
		subb	a, r3
idiv08:
		mov	r4, a
		inc	r6
		djnz	b, idiv09
		ret
;___________________________________________________________________________________________________

;___________________________________________________________________________________________________

get_t1:        
;     crc.
		mov	crc, #0
		mov	a, #0ffh
		call	rw_byte					; byte 0.
		mov	ftemper_L, a			;   .
		call	do_crc
		mov	a, #0ffh
		call	rw_byte					; byte 1.
		mov	ftemper_h, a			;   .
		call	do_crc
		ret
        
;  4   (  - crc).
get_t2: 
		mov	a,#0ffh
		call	rw_byte					; byte 2.
		call	do_crc
		mov	a, #0ffh
		call	rw_byte					; byte 3.
		call	do_crc
		ret
        
get_t3:
		mov	a, #0ffh
		call	rw_byte					; byte 4.
		call	do_crc
		mov	a,#0ffh
		call	rw_byte					; byte 5.
		call	do_crc
		ret
;  ,      .
get_t4:
		mov	a, #0ffh
		call	rw_byte					; byte 6.
		mov	fCNT_REM, a
		call	do_crc
		mov	a, #0ffh
		call	rw_byte					; byte 7.
		mov	fCNT_PER_C, a
		call	do_crc
        
;  crc.
		mov	a, #0ffh
		call	rw_byte					; byte 8 (crc).
		xch	a, b
		ret

;-----------------------------------------------------------------------------
;   crc.   A.
do_crc:
		push	acc						;save accumulator
		push	b							;save the B register
		push	acc						;save bits to be shifted
		mov	b, #8						;set shift = 8 bits ;
crc_loop:   
		xrl	a, crc					;calculate crc
		rrc	a							;move it to the carry
		mov	a, crc					;get the last crc value
		jnc	zero						;skip if data = 0
		xrl	a, #18h					;update the crc value
                                   
zero:
		rrc	a							;position the new crc
		mov	crc, a					;store the new crc
		pop	acc						;get the remaining bits
		rr		a							;position the next bit
		push	acc						;save the remaining bits
		djnz	b, crc_loop				;repeat for eight bits
		pop	acc						;clean up the stack
		pop	b							;restore the B register
		pop	acc						;restore the accumulator
		ret
;-----------------------------------------------------------------------------
; - /   1-Wire.
;   A    A.
rw_byte:
		mov	ftemp, a
		mov	r2, #8
rbloop:
		mov	a, ftemp
		clr	t_1wire					;  .
		nop
		jnb	acc.0, rb_skip01
		setb	t_1wire					;  .
rb_skip01:
		rr		a
		clr	acc.7						;     TEMP,   .
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		jnb	t_1wire, rb_skip02
		setb    acc.7
rb_skip02:
		mov	ftemp, a
;      (release =  60 .)  .
		mov	a, #14 					; (60 - 4) / 3 = 18
		call	delay
;  .
		setb	t_1wire
; -   (  ).
		nop   
		nop
;  8 ,  .
		djnz	r2, rbloop
;    acc
		mov	a, ftemp
		ret
;-----------------------------------------------------------------------------
;     700 .
reset_1wire:   
		clr	t_1wire
		mov	a, #220    
		call	delay
		setb	t_1wire
;   .
		mov	a, #110    ; 
		call	delay
		ret
        
;-----------------------------------------------------------------------------
delay:
		mov	fcounter, a
d_loop36:
		nop									; 1 us.
		djnz	fcounter, d_loop36		; 2 us.
		ret
;-----------------------------------------------------------------------------
set_rom_01:
;  1.
		mov	b, #8
		mov	r0, #set_add1
set_r_2:
		mov	r1, #rom_id0
set_r_1:
		mov	a, @r0
		mov	@r1, a
		inc	r0
		inc	r1
		djnz	b, set_r_1
		ret  
;-----------------------------------------------------------------------------
set_rom_02:
;  2.
		mov	b, #8
		mov	r0, #set_add2
		jmp	set_r_2	
;-----------------------------------------------------------------------------
match_rom_1:
;   " ".
		mov	a, #055h
		call	rw_byte
		mov	a, rom_id0
		call	rw_byte
		mov	a, rom_id1
		call	rw_byte
		mov	a, rom_id2
		call	rw_byte
		ret
        
match_rom_2:
		mov	a, rom_id3
		call	rw_byte
		mov	a, rom_id4
		call	rw_byte
		mov	a, rom_id5
		call	rw_byte
		ret
        
match_rom_3:        
		mov	a, rom_id6
		call	rw_byte
		mov	a, rom_id7
		call	rw_byte
		ret
        
;_________________res_1wire+m_rom________________________

res_mat:       
;     
		setb	res_1wire		
		jb		res_1wire, $
        
;   " ".
		setb	m_rom_1
		jb		m_rom_1, $
		setb	m_rom_2
		jb		m_rom_2, $
		setb	m_rom_3
		jb		m_rom_3, $
		ret
;_________________________________________________________

;________________   3ms________________

priv:    
		mov	byte_t0, #1
priv1:
		mov	a, byte_t0
		jnz	priv1
		ret
;______________________________________________________

;__________________ ____________________________________
   
read_at:
		call	scl_t					; 5mcs
		mov	a, #0a0h           
		call	dev_add
		mov	a, data_add			
		call	dev_add_4
		clr	t_1wire
		call	scl_t					; 5mcs		
		setb	t_1wire
		call	scl_t					; 5mcs
		mov	a, #0a1h 
		call	dev_add
		call	read_byte		
		ret
		
;__________________end  ____________________________


		
;___________________device address____________________________
; t_1wire   "1" !

dev_add:
		clr	dat					; start
		call	scl_t					; 5mcs		
dev_add_4:
;		mov	a, data_dev
;		call	scl_t					; 5mcs
		mov	b, #8
dev_add_1:
		clr	t_1wire
		rlc	a
		mov	dat, c
		call	scl_t					; 5mcs
		setb	t_1wire
		call	scl_t					; 5mcs			
		djnz	b, dev_add_1
		clr	t_1wire
		setb	dat		
		call	scl_t					; 5mcs
		setb	t_1wire				;  ack
		call	scl_t					; 5mcs
		jnb	dat, dev_add_3		; ack o'k
		setb	ack_err
		jmp	dev_add_2
dev_add_3:
		clr	ack_err	
dev_add_2:
		ret
		
;   t_1wire  dat  "1" !

;___________________end device address________________________



;___________________ 8 ________________________

; r0   

read_byte:
		mov	ep_data, #8
read_byte4:
		mov	b, #8
read_byte1:
		clr	t_1wire
		setb	dat
		call	scl_t					; 5mcs
		setb	t_1wire
		call	scl_t					; 5mcs
		mov	c, dat
		rlc	a
		djnz	b, read_byte1
		mov	@r0, a
		djnz	ep_data, read_byte2
		clr	t_1wire
		setb	dat		
		call	scl_t					; 5mcs
		setb	t_1wire				;   ack
		call	scl_t					; 5mcs
		
;stop 		
		clr	t_1wire
		clr	dat		
		call	scl_t					; 5mcs
		setb	t_1wire				;
		call	scl_t					; 5mcs
		setb	dat					; stop
		ret		

		
read_byte2:
		clr	t_1wire
		clr	dat		
		call	scl_t					; 5mcs
		setb	t_1wire				;  ack
		call	scl_t					; 5mcs
		inc	r0
		jmp	read_byte4

;___________________end  8 _______________________



;__________________ ____________________________________
   
write_byte:
		call	scl_t					; 5mcs
		mov	a, #0a0h 
		call	dev_add
;		clr	a
		mov	a, data_add			
		call	dev_add_4
;		mov	r0, #ep_i
		mov	ep_data, #8
write_byte4:
		mov	a,	@r0
		call	dev_add_4
		inc	r0		
		djnz	ep_data, write_byte4	
;stop 		
		clr	t_1wire
		clr	dat		
		call	scl_t					; 5mcs
		setb	t_1wire				;
		call	scl_t					; 5mcs
		setb	dat					; stop
		ret		

;__________________end  ____________________________




		
;______________tscl= 5 mcs____________________________________

scl_t:
		nop	
		
		ret
;______________________________________________________________


		
;______________________________________________________________		

pause_h:	
		mov	byte_t0, #255
pause_h1:
		mov   a, byte_t0
		jnz	pause_h1
		ret				
;______________________________________________________________		  



;____________________    _________________
temperatura:
		call	set_rom_01				;     .
		clr	set_rom_b            ;  1 
		call	priv
;  .    
		call	get_temperature
		call	set_rom_02				;     .
		setb	set_rom_b				;  2 
		call	priv        
;  .    
		call	get_temperature
		call	priv
		ret
;____________________end     _____________

        


;  :   
;___________________________________________
					
nadpis:
		mov	@r0, #5h				;-d
		inc	r0
		mov	@r0, #60h			;A
		inc	r0
		mov	@r0, #2bh			;t
		ret
;____________________________________________


nadp_pr:
		mov	r0, #data_2_1
		mov	@r0, #68h			;P
		inc	r0
		mov	@r0, #6fh			;r
		inc	r0
		ret

;__________________t low_____________________

indic_low:
		mov	data_2h, ep_2hl
		mov	data_10h, ep_10hl
		clr	set_rom_b				
		mov	r0, #data_2_l
		call	conv_h
		ret
;__________________end t low_____________________ 


;__________________t hi_____________________


indic_hi:
		mov	data_2h, ep_2hh
		mov	data_10h, ep_10hh
		setb	set_rom_b		
		mov	r0, #data_2_h
		call	conv_h
      ret
   
;__________________end t hi_____________________ 


;_________________low_plus______________________

low_plus:
		xch	a, ep_10hl
		add	a, #1
		da		a
		xch	a, ep_10hl
		xch	a, ep_2hl
		addc	a, #0
		da		a
		anl	a, #0fh
		xch	a, ep_2hl
		call	indic_low
		setb	inf_b
		ret       
        
;_______________end low_plus____________________

;_________________hi_plus_______________________


hi_plus:
		xch	a, ep_10hh
		add	a, #1
		da		a
		xch	a, ep_10hh
		xch	a, ep_2hh
		addc	a, #0
		da		a
		anl	a, #0fh
		xch	a, ep_2hh
		call	indic_hi
		setb	inf_b
		ret			

;_______________end hi_plus_____________________


;_________________low_minus_____________________

low_minus:
		xch	a, ep_10hl
		add	a, #99h
		da		a
		xch	a, ep_10hl
		xch	a, ep_2hl
		addc	a, #99h
		da		a
		anl	a, #0fh
		xch	a, ep_2hl
		call	indic_low
		setb	inf_b
		ret
		
;_________________end low_minus_________________


;_________________hi_minus______________________

hi_minus:
		xch	a, ep_10hh
		add	a, #99h
		da		a
		xch	a, ep_10hh
		xch	a, ep_2hh
		addc	a, #99h
		da		a
		anl	a, #0fh
		xch	a, ep_2hh
		call	indic_hi
		setb	inf_b
		ret
		
;_________________end hi_minus__________________

;______________ ________
progra:
		clr	ind_hi
		clr	ind_low
		clr	ndat
		clr	mig
		clr	inf_b
		clr	prog2
progra_3:		
; 
		call	nadp_pr
		mov	@r0, #0f5h			;1
progra_1:
		mov	a, klava
		cjne	a, #0ffh, progra_1
progra_4:		
		mov	a, klava
		jz		progra_2
		cjne	a, #1, progra_4
		jbc	prog2, progra_3
; 
		call	nadp_pr
		mov	@r0, #0ch			;.2
		setb	prog2
		jmp	progra_1		
progra_2:
;-------------------------------------------
; ,   0  
		call	priv		     
      mov	a, #0ffh
		mov	p1, a
		mov	p3, a
		clr	TCON.4			; TCON.4 - TIMER 0 ON/OFF CONTROL
		clr	IE.1				; IE.1 - TIMER 0 INTERRUPT ENABLE
		clr	IE.7				; IE.7 - GLOBAL	INTERRUPT ENABLE
;-------------------------------------------
		mov	ftry, #10		;   rom 
progra_6:
		call	read_rom		
		jb		crc_ok, progra_5
		djnz	ftry, progra_6
progra_7:
      mov	sp, #7
		jmp	init
progra_5:
		jb		prog2, progra_8
		mov	r0, #set_add1
		mov	data_add, #10h
progra_9:
		call	write_byte		;  eprom
		jmp	progra_7
progra_8:
		mov	r0, #set_add2
		mov	data_add, #20h
		jmp	progra_9
		
;___________end  _______

		
		
;_______________________read_rom_______________________________		

read_rom:
;  
		jb		prog2, read_rom3
		mov	r0, #set_add1
read_rom4:
;  read rom
		call	reset_1wire
		mov	a, #33h
		call	rw_byte					
; rom   crc
		mov	b, #7
		mov	crc, #0
read_rom1:
		mov	a, #0ffh
		call	rw_byte			
		mov	@r0, a
		inc	r0			
		call	do_crc
		djnz	b, read_rom1
		mov	a, #0ffh
		call	rw_byte
		mov	@r0, a					
      clr	c
		subb	a, crc  				; a = a - crc
		jz		read_rom2
		clr	crc_ok
		ret	
read_rom2:
		setb	crc_ok			
		ret
read_rom3:
		mov	r0, #set_add2
		jmp	read_rom4	

;__________________end read_rom________________________________			
		

       
        
        
;-----------------------------------------------------------------------------
        end
		
		




























